<template>
  <div class="w-full px-10 py-10 h-full">
    <div>
      <div class="py-4 px-2 mb-1 bg-background2 rounded-lg">
        <span>{{
          $t(
            "after_you_have_successfully_completed_your_deposit_please_contact_our_customer_support_to_get_your_preferable_bank_information"
          )
        }}</span>
      </div>
    </div>
    <div v-if="beforeSubmit" v-loading="isloading">
      <div class="w-full flex flex-col">
        <el-form
          :model="requestModel"
          ref="ruleFormRef"
          :rules="formRule"
          label-width="200px"
          label-position="top"
        >
          <span class="text-[16px] mb-2 fc-hint">{{ $t("from") }}</span>
          <el-form-item :label="$t('bank')" prop="PlayerBankName">
            <el-select
              @visible-change="onVisibleChange"
              @change="onChangeSelect"
              @blur="onChangeSelect"
              class="w-full"
              v-model="requestModel.PlayerBankName"
              default-first-option
              :placeholder="$t('select')"
            >
              <el-option
                v-for="(bank, index) in playerBankDeposit"
                :key="index"
                :label="bank.BankName"
                :value="bank.Id"
              />
            </el-select>
          </el-form-item>
          <el-form-item
            :label="$t('bank_account_name')"
            prop="PlayerBankAccountName"
          >
            <el-input
              v-un-focus
              disabled
              v-model="requestModel.PlayerBankAccountName"
            />
          </el-form-item>
          <el-form-item
            :label="$t('bank_account_number')"
            prop="PlayerBankAccountNumber"
          >
            <el-input
              v-un-focus
              disabled
              v-model="requestModel.PlayerBankAccountNumber"
            />
          </el-form-item>
          <el-form-item :label="$t('amount')" prop="Amount">
            <el-input
              v-un-focus
              oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
              v-model="requestModel.Amount"
              :placeholder="amountPlaceholder"
            >
              <template #append v-if="isNeedToMultiplyByThousand">000</template>
            </el-input>
            <span
              v-if="isNeedToMultiplyByThousand"
              class="order-1 text-xs fc-hint mt-3"
              >{{
                $t(
                  `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
                )
              }}
            </span>
          </el-form-item>
          <span class="text-[16px] mb-2 fc-hint">{{ $t("to") }}</span>
          <el-form-item :label="$t('bank')" prop="PlayerBankName">
            <el-select
              @visible-change="onVisibleChange"
              @change="onChangeSelect"
              @blur="onChangeSelect"
              class="w-full"
              v-model="requestModel.CompanyBankId"
              default-first-option
              :placeholder="$t('select')"
            >
              <el-option
                v-for="(bank, index) in autoDepositBank"
                :key="index"
                :label="bank.BankName"
                :value="bank.Id"
              />
            </el-select>
          </el-form-item>
          <div class="flex items-center justify-center">
            <el-button
              type="primary"
              round
              @click="onSubmitDeposit(ruleFormRef)"
              :loading="isloading"
              >{{ $t("submit") }}</el-button
            >
          </div>
        </el-form>
      </div>
    </div>
    <div v-else v-loading="isloading">
      <div class="w-full mb-3">
        <span class="text-[16px] mb-2 fc-hint">{{
          $t("selected_deposit_bank_account")
        }}</span>
        <el-form
          class="customize-form text-[14px]"
          label-width="170px"
          label-position="left"
        >
          <el-form-item :label="$t('bank_name')">
            <span>{{ bankName }}</span>
          </el-form-item>
          <el-form-item :label="$t('bank_account_name')">
            <span>{{ bankAccountName }}</span>
          </el-form-item>
          <el-form-item :label="$t('bank_account_number')">
            <el-button
              type="primary"
              size="small"
              @click="copyAccountNumber"
              plain
              round
              >{{ $t("copy") }}</el-button
            >
          </el-form-item>
        </el-form>
      </div>
      <div class="w-full flex flex-col items-center display-box rounded-lg p-3">
        <div class="w-full flex flex-col items-center border-color-config">
          <span class="font-semibold text-[14px] mb-3">{{
            $t("bet_balance")
          }}</span>
          <div class="flex items-start font-bold">
            <span class="mt-1 mr-1">{{ currency }}</span>
            <span class="text-xl">{{ balance }}</span>
          </div>
          <span class="my-2">{{
            $t("click_to_copy_this_exact_amount_below")
          }}</span>
          <el-button
            type="primary"
            @click="copyExactBalance"
            size="small"
            plain
            round
            >{{ $t("copy") }}</el-button
          >
        </div>
        <div class="w-full mt-3 flex flex-col items-center">
          <span class="font-semibold mb-3 text-[14px]">{{
            $t("remaining_time")
          }}</span>
          <span class="text-xl font-bold">{{ remainingTimeForDisplay }}</span>
        </div>
      </div>
      <div class="w-full flex flex-col items-center mt-3 gap-4">
        <div class="fc-hint">
          {{ $t("please_transfer_the_exact_amount_as_displayed") }}
        </div>
        <div class="flex gap-1">
          <el-button type="primary" @click="copyAccountNumber" round>{{
            $t("copy_account_number")
          }}</el-button>
          <el-button
            type="danger"
            @click="cancelTransaction"
            :loading="isloading"
            plain
            round
            >{{ $t("cancel") }}</el-button
          >
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { ProfileDto } from "@/models/getProfileResponse";
import useAutoDeposit from "@/composables/payment/deposit/useAutoDeposit";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";

export default defineComponent({
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
      default: {} as IGetTransactionBankListResponse,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
  },
  setup(props) {
    const { normalBanks, profile } = toRefs(props);
    const { onChangeSelect, onVisibleChange } = commonHelper;
    const {
      bankName,
      bankAccountName,
      currency,
      balance,
      remainingTimeForDisplay,
      copyAccountNumber,
      copyExactBalance,
      beforeSubmit,
      autoDepositBank,
      requestModel,
      isNeedToMultiplyByThousand,
      formRule,
      ruleFormRef,
      onSubmitDeposit,
      amountPlaceholder,
      cancelTransaction,
      playerBankDeposit,
      isloading,
    } = useAutoDeposit(normalBanks, profile);
    return {
      bankName,
      bankAccountName,
      cancelTransaction,
      currency,
      balance,
      remainingTimeForDisplay,
      copyAccountNumber,
      copyExactBalance,
      beforeSubmit,
      autoDepositBank,
      isNeedToMultiplyByThousand,
      requestModel,
      formRule,
      onSubmitDeposit,
      ruleFormRef,
      isloading,
      amountPlaceholder,
      playerBankDeposit,
      onChangeSelect,
      onVisibleChange,
    };
  },
});
</script>
<style lang="scss">
.customize-form {
  .el-form-item {
    margin-bottom: 0px;
  }
}
.display-box {
  border: 1px solid var(--border);
}
.border-color-config {
  border-color: var(--border);
}
.el-select {
  width: 100%;
}
</style>
